## nsis 2.43

=== SConstruct ===
EnsureSConsVersion(0,98)
	
stubs = [
	'bzip2',
	'lzma',
	'zlib'
]

plugin_libs = [
	'ExDLL'
]

plugins = [
	'AdvSplash',
	'Banner',
	'BgImage',
	'Dialer',
	'InstallOptions',
	'LangDLL',
	'Library/TypeLib',
	'Math',
	'nsDialogs',
	'nsExec',
	'NSISdl',
	'Splash',
	'StartMenu',
	'System',
	'UserInfo',
	'VPatch/Source/Plugin',
]

utils = [
	'Library/LibraryLocal',
	'Library/RegTool',
	'MakeLangId',
	'Makensisw',
	'NSIS Menu',
	'UIs',
	'VPatch/Source/GenPat',
	'zip2exe'
]

misc = [
	'Graphics',
	'Language files',
	'MultiUser',
	'Modern UI',
	'Modern UI 2',
	'VPatch'
]

doc = [
	'COPYING'
]

######################################################################
#######  Build Environment                                         ###
######################################################################

path = ARGUMENTS.get('PATH', '')
toolset = ARGUMENTS.get('TOOLSET', '')

if toolset and path:
	defenv = Environment(ENV = {'PATH' : path}, TOOLS = toolset.split(',') + ['zip'])
else:
	if path:
		defenv = Environment(ENV = {'PATH' : path})
	if toolset:
		defenv = Environment(TOOLS = toolset.split(',') + ['zip'])
if not toolset and not path:
	defenv = Environment()

Export('defenv')

######################################################################
#######  Includes                                                  ###
######################################################################

SConscript('SCons/utils.py')

######################################################################
#######  Options                                                   ###
######################################################################

import os
hhc = 'no'
if defenv.WhereIs('hhc', os.environ['PATH']):
	hhc = 'yes'

from time import strftime, gmtime
cvs_version = strftime('%d-%b-%Y.cvs', gmtime())

opts = Variables()

# load configuration options
#  it's important this will be done here so NSIS_CONFIG_CONST_DATA_PATH
#  will be available for the next few lines and so `dirs` can be set
SConscript('SCons/config.py')

opts.Update(defenv)
Help(opts.GenerateHelpText(defenv))

install_dirs = {
	'relocatable': {
		'dest': '',
		'prefix': '',
		'conf': '$PREFIX',
		'bin': '$PREFIX',
		'data': '$PREFIX',
		'doc': '$PREFIX'
	},
	'static': {
		'dest': '',
		'prefix': '/usr/local',
		'conf': '$PREFIX/etc',
		'bin': '$PREFIX/bin',
		'data': '$PREFIX/share/nsis',
		'doc': '$PREFIX/share/doc/nsis'
	}
}

if 'NSIS_CONFIG_CONST_DATA_PATH' in defenv['NSIS_CPPDEFINES']:
	dirs = install_dirs['static']
else:
	dirs = install_dirs['relocatable']

if 'msvc' in defenv['TOOLS'] or 'mstoolkit' in defenv['TOOLS']:
	ignore_tests = 'none'
else:
	ignore_tests = ','.join(Split("""
Examples/makensis.nsi
Examples/gfx.nsi"""))

# version
opts.Add(('VERSION', 'Version of NSIS', cvs_version))
opts.Add(('VER_MAJOR', 'Major version of NSIS (recommended for dist-installer)', None))
opts.Add(('VER_MINOR', 'Minor version of NSIS (recommended for dist-installer)', None))
opts.Add(('VER_REVISION', 'Revision of NSIS (recommended for dist-installer)', None))
opts.Add(('VER_BUILD', 'Build version of NSIS (recommended for dist-installer)', None))
# installation
opts.Add(('PREFIX', 'Installation prefix', dirs['prefix']))
opts.Add(ListVariable('SKIPSTUBS', 'A list of stubs that will not be built', 'none', stubs))
opts.Add(ListVariable('SKIPPLUGINS', 'A list of plug-ins that will not be built', 'none', plugins))
opts.Add(ListVariable('SKIPUTILS', 'A list of utilities that will not be built', 'none', utils))
opts.Add(ListVariable('SKIPMISC', 'A list of plug-ins that will not be built', 'none', misc))
opts.Add(ListVariable('SKIPDOC', 'A list of doc files that will not be built/installed', 'none', doc))
opts.Add(('SKIPTESTS', 'A comma-separated list of test files that will not be ran', 'none'))
opts.Add(('IGNORETESTS', 'A comma-separated list of test files that will be ran but ignored', ignore_tests))
# build tools
opts.Add(('PATH', 'A colon-separated list of system paths instead of the default - TEMPORARY AND MAY DEPRECATE', None))
opts.Add(('TOOLSET', 'A comma-separated list of specific tools used for building instead of the default', None))
opts.Add(BoolVariable('MSTOOLKIT', 'Use Microsoft Visual C++ Toolkit', 'no'))
opts.Add(BoolVariable('CHMDOCS', 'Build CHM documentation, requires hhc.exe', hhc))
opts.Add(PathVariable('APPEND_CPPPATH', 'Additional paths to search for include files', None))
opts.Add(PathVariable('APPEND_LIBPATH', 'Additional paths to search for libraries', None))
opts.Add(('APPEND_CCFLAGS', 'Additional C/C++ compiler flags'))
opts.Add(('APPEND_LINKFLAGS', 'Additional linker flags'))
# build options
opts.Add(BoolVariable('DEBUG', 'Build executables with debugging information', 'no'))
opts.Add(PathVariable('CODESIGNER', 'A program used to sign executables', None))
opts.Add(BoolVariable('STRIP', 'Strips executables of any unrequired data such as symbols', 'yes'))
opts.Add(BoolVariable('STRIP_CP', 'Strips cross-platform executables of any unrequired data such as symbols', 'yes'))
opts.Add(BoolVariable('STRIP_W32', 'Strips Win32 executables of any unrequired data such as symbols', 'yes'))
# path related build options
opts.Add(('PREFIX_DEST', 'Intermediate installation prefix (extra install time prefix)', dirs['dest']))
opts.Add(('PREFIX_CONF', 'Path to install nsisconf.nsh to', dirs['conf']))
opts.Add(('PREFIX_BIN', 'Path to install native binaries to', dirs['bin']))
opts.Add(('PREFIX_DATA', 'Path to install nsis data to (plugins, includes, stubs, contrib, win32 binaries)', dirs['data']))
opts.Add(('PREFIX_DOC','Path to install nsis README / INSTALL / TODO files to.', dirs['doc']))
opts.Add(('PREFIX_PLUGINAPI_INC','Path to install plugin API headers to.', None))
opts.Add(('PREFIX_PLUGINAPI_LIB','Path to install plugin static library to.', None))

opts.Update(defenv)
Help(opts.GenerateHelpText(defenv))

# add prefixes defines
if 'NSIS_CONFIG_CONST_DATA_PATH' in defenv['NSIS_CPPDEFINES']:
	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_CONF', '"%s"' % defenv.subst('$PREFIX_CONF'))])
	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_DATA', '"%s"' % defenv.subst('$PREFIX_DATA'))])

# Need this early for the config header files to be placed in
if defenv['DEBUG']:
	defenv.Replace(BUILD_PREFIX = 'build/debug')
else:
	defenv.Replace(BUILD_PREFIX = 'build/release')

defenv.Replace(BUILD_CONFIG = defenv.subst('$BUILD_PREFIX/config'))

# ensure the config directory exists
defenv.Execute(Mkdir(defenv.Dir('#$BUILD_CONFIG')))

# write configuration into sconf.h and defines.h
sconf_h = open(defenv.File('#$BUILD_CONFIG/nsis-sconf.h').abspath, 'w')
sconf_h.write('// This file is automatically generated by SCons\n// DO NOT EDIT THIS FILE\n')

defines_h = open(defenv.File('#$BUILD_CONFIG/nsis-defines.h').abspath, 'w')
defines_h.write('// This file is automatically generated by SCons\n// DO NOT EDIT THIS FILE\n')

for i in defenv['NSIS_CPPDEFINES']:
	if type(i) is not str:
		sconf_h.write('#define %s %s\n' % (i[0], i[1]))
		if str(i[1])[0] != '"':
			defines_h.write('definedlist.add("%s", "%s");\n' % (i[0], i[1]))
		else:
			defines_h.write('definedlist.add("%s", %s);\n' % (i[0], i[1]))
	else:
		sconf_h.write('#define %s\n' % (i))
		defines_h.write('definedlist.add("%s");\n' % (i))
sconf_h.close()
defines_h.close()

# write version into version.h
f = open(defenv.File('#$BUILD_CONFIG/nsis-version.h').abspath, 'w')
f.write('// This file is automatically generated by SCons\n// DO NOT EDIT THIS FILE\n')
f.write('#define NSIS_VERSION "v%s"\n' % defenv['VERSION'])
f.close()

######################################################################
#######  Functions                                                 ###
######################################################################

defenv['ZIPDISTDIR'] = defenv.Dir('#nsis-$VERSION')
defenv['INSTDISTDIR'] = defenv.Dir('#.instdist')
defenv['TESTDISTDIR'] = defenv.Dir('#.test')
defenv['DISTSUFFIX'] = ''

if defenv.has_key('CODESIGNER'):
	defenv['DISTSUFFIX'] = '-signed'

defenv.Execute(Delete('$ZIPDISTDIR'))
defenv.Execute(Delete('$INSTDISTDIR'))
defenv.Execute(Delete('$TESTDISTDIR'))

def SafeFile(f):
	from types import StringType

	if isinstance(f, StringType):
		return File(f)

	return f

def MakeFileList(files):
	return Flatten(File(files))

def Distribute(files, names, component, path, subpath, alias, install_alias=None):
	from types import StringType

	files = MakeFileList(files)

	names = names or map(lambda x: x.name, files)
	if isinstance(names, StringType):
		names = [names]

	for d in ('$ZIPDISTDIR', '$INSTDISTDIR', '$TESTDISTDIR'):
		paths = map(lambda file: os.path.join(d, path, subpath, file), names)
		defenv.InstallAs(paths, files)

	if (defenv.has_key('PREFIX') and defenv['PREFIX']) or (defenv.has_key('PREFIX_DEST') and defenv['PREFIX_DEST']) :
		prefix = '${PREFIX_DEST}${PREFIX_%s}' % component.upper()
		paths = map(lambda file: os.path.join(prefix, path, subpath, file), names)
		ins = defenv.InstallAs(paths, files)
	else:
		ins = []

	if ins:
		defenv.Alias('install', ins)
		defenv.Alias('install-%s' % component, ins)
		if alias:
			defenv.Alias(alias, ins)
		if install_alias:
			defenv.Alias('install-%s' % install_alias, ins)

		return ins

def DistributeBin(files, names=[], path='', alias=None):
	return defenv.Distribute(files, names, 'bin', '', path, alias)

def DistributeConf(files, names=[], path='', alias=None):
	return defenv.Distribute(files, names, 'conf', '', path, alias)

def DistributeW32Bin(files, names=[], path='', alias=None):
	return defenv.Distribute(files, names, 'data', 'Bin', path, alias, 'w32bin')

def DistributeStubs(files, names=[], path='', alias=None):
	return defenv.Distribute(files, names, 'data', 'Stubs', path, alias, 'stubs')

def DistributePlugin(files, names=[], path='', alias=None):
	return defenv.Distribute(files, names, 'data', 'Plugins', path, alias, 'plugins')

def DistributeContrib(files, names=[], path='', alias=None):
	return defenv.Distribute(files, names, 'data', 'Contrib', path, alias, 'contrib')

def DistributeMenu(files, names=[], path='', alias=None):
	return defenv.Distribute(files, names, 'data', 'Menu', path, alias, 'menu')

def DistributeInclude(files, names=[], path='', alias=None):
	return defenv.Distribute(files, names, 'data', 'Include', path, alias, 'includes')

def DistributeDoc(files, names=[], path='', alias=None):
	return defenv.Distribute(files, names, 'doc', '', path, alias)

def DistributeDocs(files, names=[], path='', alias=None):
	return defenv.Distribute(files, names, 'doc', 'Docs', path, alias, 'docs')

def DistributeExamples(files, names=[], path='', alias=None):
	return defenv.Distribute(files, names, 'doc', 'Examples', path, alias, 'examples')

def Sign(targets):
	if defenv.has_key('CODESIGNER'):
		for t in targets:
			a = defenv.Action('$CODESIGNER "%s"' % t.path)
			defenv.AddPostAction(t, a)

def TestScript(scripts):
	defenv.Install('$TESTDISTDIR/Tests', scripts)

defenv.Distribute = Distribute
defenv.DistributeBin = DistributeBin
defenv.DistributeConf = DistributeConf
defenv.DistributeW32Bin = DistributeW32Bin
defenv.DistributeStubs = DistributeStubs
defenv.DistributePlugin = DistributePlugin
defenv.DistributeContrib = DistributeContrib
defenv.DistributeMenu = DistributeMenu
defenv.DistributeInclude = DistributeInclude
defenv.DistributeDoc = DistributeDoc
defenv.DistributeDocs = DistributeDocs
defenv.DistributeExamples = DistributeExamples
defenv.Sign = Sign
defenv.TestScript = TestScript

######################################################################
#######  Environments                                              ###
######################################################################

if defenv['MSTOOLKIT']:
	defenv.Tool('mstoolkit', toolpath = [Dir('SCons/Tools').rdir()])

defenv.Append(CCFLAGS = Split('$APPEND_CCFLAGS'))
defenv.Append(LINKFLAGS = Split('$APPEND_LINKFLAGS'))
defenv.Append(CPPPATH = Split('$APPEND_CPPPATH'))
defenv.Append(LIBPATH = Split('$APPEND_LIBPATH'))

## nsis 2.46

=== debian/changelog ===
nsis (2.46-7) unstable; urgency=low

  * Make plugins not depend on libgcc_s_sjlj-1.dll nor libdtdc++-6.dll
    by forcing static compilation of both libgcc and libstdc++. (Closes:
    #654380)

 -- Didier Raboud <odyx@debian.org>  Thu, 05 Jan 2012 19:06:42 +0100

nsis (2.46-6) unstable; urgency=low

  * Corrected command line options passed to scons for build/NEWS target.
  * Use zmemcpy function of the same calling convention. 

 -- Thomas Gaugler <thomas@dadie.net>  Fri, 07 Oct 2011 10:28:21 +0200

nsis (2.46-5) unstable; urgency=low

  * Add Replaces/Breaks against nsis to the new packages (Closes: #630620)

 -- Thomas Gaugler <thomas@dadie.net>  Sat, 18 Jun 2011 16:41:54 +0000

nsis (2.46-4) unstable; urgency=low

  [ Thomas Gaugler ]
  * Run architecture independent build process only when demanded.
  * Split NSIS package into four packages:
    - compiler and utilities (architecture dependent)
    - plugins, stubs and resource files (win32)
    - header and library files for developing NSIS plugins (win32)
    - examples and HTML documentation (architecture independent)
  * Updated to Standards-Version 3.9.2
  * Support building with mingw-w64 (Closes: #620099)
  * Support parallel build 

  [ Didier Raboud ]
  * Don't hide output from scons in clean.
  * Move packaging from Subversion to Git, update Vcs-* fields.
  * Add explicit libstdc++6-4.6-dev Build-Depend.

 -- Thomas Gaugler <thomas@dadie.net>  Sat, 11 Jun 2011 15:24:40 +0000

nsis (2.46-3) experimental; urgency=low

  * Fixed warnings of missing elements occuring in man page generation
  * Use variant_dir instead of build_dir keyword in SConstruct file
  * Run complete set of tests independent of architecture
  * Removed the option to build with the orphaned gcc-mingw32
  * Removed architecture restrictions
  * Updated to Standards-Version 3.9.1

 -- Thomas Gaugler <thomas@dadie.net>  Sun, 07 Nov 2010 17:30:30 +0000

nsis (2.46-2) unstable; urgency=low

  * Updated zlib patch with changes from upstream subversion repository
  * Made embedded inflate function compatible with zlib (Closes: #579407)
  * Exclude unneeded win32-only utilities from building
  * Build makensis and portable utilities natively for amd64

 -- Thomas Gaugler <thomas@dadie.net>  Wed, 05 May 2010 20:39:58 +0000

nsis (2.46-1) unstable; urgency=low

  [ Thomas Gaugler ]
  * New upstream release
  * Switch to 3.0 (quilt) source format
  * Use the system provided compression library of zlib
  * Switch to debhelper 7's minimal rules file mode

  [ Paul Wise ]
  * Link against the 32-bit zlib on amd64 to prevent FTBFS

 -- Thomas Gaugler <thomas@dadie.net>  Tue, 22 Dec 2009 18:53:50 +0000

nsis (2.45-1) unstable; urgency=low

  * New upstream release
  * Adopted package from Paul Wise with his permission
  * Allow building with either gcc-mingw32 (>= 4.4.0-3) or mingw32
  * Fixed occurring access violation in Math plugin once the 
    installer window is closed.

 -- Thomas Gaugler <thomas@dadie.net>  Mon, 17 Aug 2009 19:04:01 +0000

nsis (2.44-4) unstable; urgency=low

  * Brown paper bag upload
  * Actually give the option to dh_strip (closes: #519703)

 -- Paul Wise <pabs@debian.org>  Fri, 20 Mar 2009 12:07:00 +0900

nsis (2.44-3) unstable; urgency=low

  * Don't let dh_strip work on (and break) the libpluginapi.a file
    (Closes: #519703).
  * Support new nocheck option in DEB_BUILD_OPTIONS
  * Bump Standards-Version, nsis now complies

 -- Paul Wise <pabs@debian.org>  Mon, 16 Mar 2009 01:26:29 +0900

nsis (2.44-2) unstable; urgency=low

  * Woops, actually upload to unstable
  * Use dh_lintian instead of manually installing overrides
  * Switch to debhelper compat level 7
  * Switch from dh_clean -k to dh_prep

 -- Paul Wise <pabs@debian.org>  Wed, 25 Feb 2009 01:03:19 +0900

nsis (2.44-1) experimental; urgency=low

  * New upstream bugfix release
    - drop merged fix-Library.nsi-test.patch
  * Move to unstable now that lenny is released
  * Add missing System Call.S copyright info

 -- Paul Wise <pabs@debian.org>  Tue, 24 Feb 2009 17:51:13 +0900

nsis (2.43-1) experimental; urgency=low

  * New upstream release (w00t)
    - Finally makes the System plugin fully functional. Thanks a lot to
      Thomas Gaugler for implementing this (Closes: #319999, LP: #157356)
    - Compiles Resource.dll from an icon and a short .rc (Closes: #442192)
    - Building nsis plugins changes with this release, add details to
      README.Debian and a notification in NEWS.Debian.
  * Add some more items to the TODO file.
  * Apply upstream patch to fix the Library.nsi test
  * Refer to the correct GPL version in the copyright file

 -- Paul Wise <pabs@debian.org>  Thu, 05 Feb 2009 17:52:53 +0900

nsis (2.39-1) experimental; urgency=low

  * New upstream release

 -- Paul Wise <pabs@debian.org>  Wed, 27 Aug 2008 13:09:09 +0800

nsis (2.38-1) experimental; urgency=low

  * New upstream release
    - all patches included
  * Put in experimental because it breaks win32-loader

 -- Paul Wise <pabs@debian.org>  Wed, 16 Jul 2008 16:16:58 +0800

nsis (2.37-2) unstable; urgency=medium

  * Ensure the package will FTBFS when makensis is not built
  * The rebuild should create makensis on amd64 (Closes: #484938)
  * Don't run the patch, build and test process twice
  * Run the tests as well as the test scripts on i386 only
  * Fix FTBFS when converted to dpkg source format 3.0 (Closes: #485350)
  * Bump Standards-Version (no changes needed)

 -- Paul Wise <pabs@debian.org>  Mon, 09 Jun 2008 15:42:38 +0800

nsis (2.37-1) unstable; urgency=low

  * New upstream release
    - all patches included
  * Apply upstream patch to fix the HeaderBitmap test failure

 -- Paul Wise <pabs@debian.org>  Sun, 18 May 2008 18:32:18 +0800

nsis (2.36-1) unstable; urgency=low

  * New upstream release
    - all patches included

 -- Paul Wise <pabs@debian.org>  Mon, 07 Apr 2008 13:35:41 +0800

nsis (2.35-2) unstable; urgency=low

  * Brown paper bag release


=== debian/control ===
Source: nsis
Section: devel
Priority: optional
Maintainer: Thomas Gaugler <thomas@dadie.net>
Uploaders: Didier Raboud <odyx@debian.org>
Build-Depends: debhelper (>= 7.0.50~), scons (>= 1.2.0), xmlto, html2text, libcppunit-dev, zlib1g-dev, mingw-w64 (>= 1.0), libstdc++6-4.6-dev
Standards-Version: 3.9.2
Homepage: http://nsis.sourceforge.net/
Vcs-Git: git://git.debian.org/collab-maint/nsis.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/nsis.git

Package: nsis
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, nsis-common (>= ${source:Version})
Suggests: nsis-doc (>= ${source:Version}), nsis-pluginapi (>= ${source:Version}), mingw-w64 (>= 1.0), wine
Description: Nullsoft Scriptable Install System (modified for Debian)
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 NSIS creates installers that are capable of installing, uninstalling,
 setting system settings, extracting files, etc. Because it's based on
 script files, you can fully control every part of your installers. The
 script language supports variables, functions, string manipulation,
 just like a normal programming language - but designed for the creation
 of installers. Even with all these features, NSIS is still the smallest
 installer system available. With the default options, it has an overhead
 of only 34 KB.

Package: nsis-common
Architecture: all
Depends: ${misc:Depends}
Replaces: nsis (<< 2.46-4)
Breaks: nsis (<< 2.46-4)
Description: Nullsoft Scriptable Install System stubs and plugins
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains the stubs and plugins of NSIS.

Package: nsis-pluginapi
Architecture: all
Depends: ${misc:Depends}
Replaces: nsis (<< 2.46-4)
Breaks: nsis (<< 2.46-4)
Recommends: mingw-w64 (>= 1.0)
Enhances: nsis (>= ${source:Version})
Description: Nullsoft Scriptable Install System plugin API
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains the header and library files for developing
 NSIS plugins.

Package: nsis-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Replaces: nsis (<< 2.46-4)
Breaks: nsis (<< 2.46-4)
Description: Nullsoft Scriptable Install System documentation
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains examples and the documentation in HTML format.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Exclude .svn directories from packages
export DH_ALWAYS_EXCLUDE=.svn

VERSION=${shell dpkg-parsechangelog | sed -n 's/^Version: *//p'}
PREFIX=/usr

# Variables for Win32 cross compiler
XGCC_W32 = $(shell which i686-w64-mingw32-gcc)
ifneq ($(strip $(XGCC_W32)),)
	XGCC_W32_PATH = $(abspath $(shell $(XGCC_W32) -print-file-name=libkernel32.a)/../..)
	XGCC_W32_PREFIX = $(subst -gcc,-,$(notdir $(XGCC_W32)))
endif

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
TEST=
else
TEST=test
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	SCONSFLAGS = -j $(NUMJOBS)
endif

SCONSOPTS = $(SCONSFLAGS) VERSION=$(VERSION) \
  PREFIX=$(PREFIX) PREFIX_CONF=/etc \
  CHMDOCS=0 \
  APPEND_CCFLAGS="-Wall -g -O$(if $(findstring noopt,$(DEB_BUILD_OPTIONS)),0,2)" \
  APPEND_LINKFLAGS="-Wall -g -O$(if $(findstring noopt,$(DEB_BUILD_OPTIONS)),0,2)"\
  STRIP_CP=no $(if $(findstring nostripfull,$(DEB_BUILD_OPTIONS)),STRIP_W32=no,)

ifdef XGCC_W32_PATH
SCONSOPTS := $(SCONSOPTS) \
  PREFIX_PLUGINAPI_INC=$(XGCC_W32_PATH)/include/ \
  PREFIX_PLUGINAPI_LIB=$(XGCC_W32_PATH)/lib/ \
  XGCC_W32_PREFIX=$(XGCC_W32_PREFIX)
endif

COMMA := ,

UTILS_ALL = 'Library/LibraryLocal,Library/RegTool,MakeLangId,Makensisw,NSIS Menu,UIs,SubStart,VPatch/Source/GenPat,zip2exe'

IGNORE_UTILS_NSIS  := $(subst Library/LibraryLocal$(COMMA),,$(UTILS_ALL))
IGNORE_UTILS_NSIS   := $(subst $(COMMA)VPatch/Source/GenPat,,$(IGNORE_UTILS_NSIS))
IGNORE_UTILS_CLEAN  := $(subst Library/LibraryLocal$(COMMA)Library/RegTool$(COMMA),,$(UTILS_ALL))
IGNORE_UTILS_CLEAN  := $(subst $(COMMA)UIs,,$(IGNORE_UTILS_CLEAN))
IGNORE_UTILS_COMMON := $(IGNORE_UTILS_CLEAN)
IGNORE_UTILS_CLEAN  := $(subst $(COMMA)SubStart,,$(IGNORE_UTILS_CLEAN))
IGNORE_UTILS_CLEAN  := $(subst $(COMMA)VPatch/Source/GenPat,,$(IGNORE_UTILS_CLEAN))

SCONSOPTS_NSIS   := $(SCONSOPTS) SKIPUTILS=$(IGNORE_UTILS_NSIS) SKIPDOC=COPYING
SCONSOPTS_COMMON := $(SCONSOPTS) SKIPUTILS=$(IGNORE_UTILS_COMMON) \
			SKIPDOC=COPYING
SCONSOPTS_CLEAN  := $(SCONSOPTS) SKIPUTILS=$(IGNORE_UTILS_CLEAN)
SCONSOPTS_TEST   := $(SCONSOPTS) SKIPUTILS=$(IGNORE_UTILS_COMMON)

INSTALL_nsis = install-utils install-compiler install-conf
INSTALL_nsis-common = install-stubs install-plugins install-data install-utils
INSTALL_nsis-pluginapi = install-pluginapi
INSTALL_nsis-doc = install-examples install-doc

# Exclude test scripts not appropriate for POSIX platforms.
IGNORE_TESTS = makensis.nsi|gfx.nsi

# Path to .nsi scripts
SCRIPTS_PATH = $(PREFIX)/share/doc/nsis/Examples

# Release notes 
NEWS = $(PREFIX)/share/doc/nsis/Docs/AppendixF.html

define DO_SCONS_INSTALL
	scons $(1) PREFIX_DEST="$(CURDIR)/debian/$(2)" $(INSTALL_$(2)) || exit 1;
endef

clean build:
	dh "$@"

build/NEWS:
	if [ -e "$(CURDIR)/debian/nsis-doc$(NEWS)" ]; then \
		news_file="$(CURDIR)/debian/nsis-doc$(NEWS)"; \
	else \
		scons $(SCONSOPTS_COMMON) Docs/src; \
		news_file="build/*/Docs/html/AppendixF.html"; \
	fi; \
	html2text -nobs "$${news_file}" | sed -e '0,/^\*\*\*\*\*/c\NSIS Release Notes (automatically converted from AppendixF.html)' -e 's/F\.[.0-9]* //g' -e 's/^\*\*\*\** *\([^*]*\)  *\**\*\*\*/\n\1\n/g' -e '/Changelog/d' -e '/^NSIS_1.x_version_history/,/^=/c\    http://nsis.sourceforge.net/download/nsis1/' -e 's/^\(Released.*\)/    \1\n/g' | cat -s > "$@"


override_dh_auto_clean:
	scons -c $(SCONSOPTS_CLEAN) 2>&1
	-rm -rf .sconf_temp .sconsign.dblite SCons/Tools/crossmingw.pyc build config.log .test
	-rm -f Source/exehead/sconf.h Source/version.h Source/defines.h config.log

build-indep:
ifdef XGCC_W32_PATH
	scons $(SCONSOPTS_COMMON) Docs/src stubs plugins utils
	html2text -style pretty -nobs -o "build/README.Modern UI" "Contrib/Modern UI/Readme.html"
	html2text -style pretty -nobs -o "build/README.Modern UI 2" "Contrib/Modern UI 2/Readme.html"
	html2text -style pretty -nobs -o build/README.VPatch Contrib/VPatch/Readme.html
	html2text -style pretty -nobs -o build/README.InstallOptions Contrib/InstallOptions/Readme.html
	html2text -style pretty -nobs -o build/README.MultiUser Contrib/MultiUser/Readme.html
	html2text -style pretty -nobs -o build/README.nsDialogs Contrib/nsDialogs/Readme.html
endif

build-arch:
	scons $(SCONSOPTS_NSIS) utils makensis
	xmlto -o build man debian/makensis.xml
	xmlto -o build man debian/GenPat.xml
	xmlto -o build man debian/LibraryLocal.xml

test:
	if [ x$(TEST) != x ] ; then \
		if [ -d "$(CURDIR)/debian/nsis-common$(PREFIX)/share/nsis" ] ; then \
			scons $(SCONSOPTS_TEST) $(TEST); \
		else \
			scons $(SCONSOPTS_NSIS) PREFIX_DEST="$(CURDIR)/.test" $(INSTALL_nsis); \
			for script_path in $(SCRIPTS_PATH)/*.nsi \
				$(SCRIPTS_PATH)/*/*.nsi; do \
				script=$${script_path#$(SCRIPTS_PATH)/}; \
				if [ "$${script%/*}" != "$${script}" ]; then \
					mkdir -p ".test/$${script%/*}"; \
				fi; \
				case $${script} in \
				$(IGNORE_TESTS)) ;; \
				*) \
				if [ -f "$${script_path}" ]; then \
					PATH=$(PATH):$(CURDIR)/.test$(PREFIX)/bin ".test$(PREFIX)/bin/makensis" \
					"$${script_path}" \
					-X"OutFile \"$(CURDIR)/.test/$${script%.nsi}.exe\"" || exit 1; \
				fi;; \
				esac; \
			done; \
		fi; \
	fi

install-indep:
	dh "install" --before dh_auto_install
ifdef XGCC_W32_PATH
	$(foreach p,$(PKGS),$(call DO_SCONS_INSTALL,$(SCONSOPTS_COMMON),$(p)))
	# Exclude any architecture dependent binaries from nsis-common
	rm -rf "$(CURDIR)/debian/nsis-common/usr/bin"
	# Fix permissions for plugin API
	find "$(CURDIR)/debian/nsis-pluginapi$(MINGW32_PATH)" \
		"$(CURDIR)/debian/nsis-common/usr/share/nsis" \
		-type f -perm +111 -exec chmod a-x {} \;
	# Clean up examples and documentation
	# The docs file can't seem to have spaces within the file name(s)
	dh_installdocs -pnsis-doc "build/README.Modern UI" \
		"build/README.Modern UI 2"
	rm "debian/nsis-doc/usr/share/doc/nsis/Docs/Modern UI/License.txt"
	rm "debian/nsis-doc/usr/share/doc/nsis/Docs/Modern UI 2/License.txt"
	rm "debian/nsis-doc/usr/share/doc/nsis/Docs/NSISdl/License.txt"
	# Remove reference to License text file in Modern UI examples
	# to enable their compilation with makensis
	cd "$(CURDIR)/debian/nsis-doc/usr/share/doc/nsis/Examples/Modern UI"; \
	ls *.nsi | xargs -i{} sed -i -e 's/$${NSISDIR}\\Docs\\Modern UI\\License.txt/{}/g' "{}"
endif

install-arch:
	dh "install" --before dh_auto_install
	$(foreach p,$(PKGS),$(call DO_SCONS_INSTALL,$(SCONSOPTS_NSIS),$(p)))
	find "$(CURDIR)/debian/nsis/etc" \
		-type f -perm +111 -exec chmod a-x {} \;

override_dh_compress:
	dh_compress -X.nlf -X.nsh -X.nsi -X.dll
	# Adapt links to documents with those of their compressed version
	if [ -d debian/nsis-doc/usr/share/doc/nsis ]; then \
		cd debian/nsis-doc/usr/share/doc/nsis ; \
		find ./ -mindepth 2 -iname \*.gz | \
		sed -e 's,.gz$$,,g' -e 's, ,%20,g' | \
		xargs -i88 sh -c 'fgrep -rl "88\"" . | \
		xargs -i{} sed -i -e "s|88\"|88.gz\"|g" "{}"'; \
	fi

binary-indep: PKGS = $(shell dh_listpackages -i)
binary-indep: build-indep install-indep
	dh "$@"

binary-arch: PKGS = $(shell dh_listpackages -a)
binary-arch: build-arch build/NEWS test install-arch
	dh "$@"

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install-arch install-indep test
.NOTPARALLEL: binary

=== debian/watch ===
version=3
http://sf.net/nsis/nsis-([\d.]*)-src.tar.bz2 debian uupdate

## nsis 2.50

=== debian/changelog ===
nsis (2.50-1) unstable; urgency=medium

  [ Thomas Gaugler ]
  * New upstream release
    - Fixed CreateShortcut failure on Vista caused by security changes
  * Switched to using DocBook 5 and xsltproc for manpage generation
    because the xmlto package has no longer a maintainer.
  * Acknowledge NMU

  [ Didier Raboud ]
  * Refresh all patches for 2.50

 -- Didier Raboud <odyx@debian.org>  Wed, 13 Jan 2016 22:02:48 +0100

nsis (2.48-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Use "find -perm /x" instead of "find -perm +x". Closes: #808934

 -- Andreas Metzler <ametzler@debian.org>  Tue, 29 Dec 2015 15:02:57 +0100

nsis (2.48-2) unstable; urgency=medium

  * Build makensis in build-indep to fix indep-only FTBFS

 -- Didier Raboud <odyx@debian.org>  Tue, 15 Dec 2015 15:02:09 +0100

nsis (2.48-1) unstable; urgency=medium

  * New upstream release
    - LoadLibrary security hardening to prevent dll hijacking
      (Bug #1125, Closes: #806036)

  * Updated to Standards-Version 3.9.6
  * Acknowledge NMU

 -- Thomas Gaugler <thomas@dadie.net>  Tue, 15 Dec 2015 10:51:30 +0100

nsis (2.46-10.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with -fgnu89-inline. Closes: #778029.

 -- Matthias Klose <doko@debian.org>  Fri, 10 Jul 2015 13:59:55 +0200

nsis (2.46-10) unstable; urgency=medium

  * Fail the build if libwinpthread is needed at runtime (see #722898)

 -- Didier Raboud <odyx@debian.org>  Mon, 15 Dec 2014 22:58:06 +0100

nsis (2.46-9) unstable; urgency=medium

  [ Didier Raboud ]
  * Update Vcs-* URLs to be canonical.

  [ Thomas Gaugler ]
  * Fix of GCC stdcall attribute warnings occurring for targets other
    than Windows.
  * Overwrite lintian warning about missing Large File Support (LFS). 
  * Replace duplicate image files of Modern UI with symbolic links. 
  * Probe for built makensis instead of using wildcard function.
  * Use correct syntax for invoking shell function from make.
  * Rely on PATH environment for finding mingw-w64 rather than
    explicitly searching for it.
  * Suggest wine package for any architecture it is available.
  * Fix test run on s390x by using stdint.h for portable data type
    definitions. (Closes: #754679)

 -- Thomas Gaugler <thomas@dadie.net>  Mon, 14 Jul 2014 20:25:01 +0200

nsis (2.46-8) unstable; urgency=low

  * Dropped superfluous build dependency of libstdc++6-4.6-dev because
    this build dependency is fulfilled by build-essential. (Closes:
    #747982)
  * Updated to Standards-Version 3.9.5.
  * Use wildcard function of make instead of relying on shell for path
    expansion.
  * Honor hardening flags.
  * Fix of mingw-w64 warnings concerning out of bounds array access.
  * Deploy variables for path names in debian/rules.
  * Upgraded to debhelper version 9.
  * Defined override targets for arch and indep packages.
  * Introduced variables for build directory and type in debian/rules.
  * Retain same flags for build and installation to avoid rebuilding. 

 -- Thomas Gaugler <thomas@dadie.net>  Sun, 25 May 2014 11:35:48 +0200

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,16 @@
 Priority: optional
 Maintainer: Thomas Gaugler <thomas@dadie.net>
 Uploaders: Didier Raboud <odyx@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), scons (>= 1.2.0), xmlto, html2text, libcppunit-dev, zlib1g-dev, mingw-w64 (>= 1.0), libstdc++6-4.6-dev
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 9), docbook5-xml, docbook-xsl-ns, html2text, libcppunit-dev, mingw-w64 (>= 1.0), scons (>= 1.2.0), xsltproc, zlib1g-dev
+Standards-Version: 3.9.6
 Homepage: http://nsis.sourceforge.net/
-Vcs-Git: git://git.debian.org/collab-maint/nsis.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/nsis.git
+Vcs-Git: https://alioth.debian.org/anonscm/git/collab-maint/nsis.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/nsis.git
 
 Package: nsis
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, nsis-common (>= ${source:Version})
-Suggests: nsis-doc (>= ${source:Version}), nsis-pluginapi (>= ${source:Version}), mingw-w64 (>= 1.0), wine
+Suggests: nsis-doc (>= ${source:Version}), nsis-pluginapi (>= ${source:Version}), mingw-w64 (>= 1.0), wine [amd64 i386 kfreebsd-amd64 kfreebsd-i386 powerpc]
 Description: Nullsoft Scriptable Install System (modified for Debian)
  NSIS is a tool for creating quick and user friendly installers for
  Microsoft Windows (Win32) operating systems.

## nsis 2.51

=== SConstruct ===
--- 
+++ 
@@ -155,6 +155,7 @@
 opts.Add(PathVariable('APPEND_LIBPATH', 'Additional paths to search for libraries', None))
 opts.Add(('APPEND_CCFLAGS', 'Additional C/C++ compiler flags'))
 opts.Add(('APPEND_LINKFLAGS', 'Additional linker flags'))
+opts.Add(PathVariable('WXWIN', 'Path to wxWindows library folder (e.g. C:\\Dev\\wxWidgets-2.8.10)', os.environ.get('WXWIN')))
 # build options
 opts.Add(BoolVariable('DEBUG', 'Build executables with debugging information', 'no'))
 opts.Add(PathVariable('CODESIGNER', 'A program used to sign executables', None))
@@ -338,6 +339,3 @@
 
 defenv.Append(CCFLAGS = Split('$APPEND_CCFLAGS'))
 defenv.Append(LINKFLAGS = Split('$APPEND_LINKFLAGS'))
-defenv.Append(CPPPATH = Split('$APPEND_CPPPATH'))
-defenv.Append(LIBPATH = Split('$APPEND_LIBPATH'))
-

=== debian/changelog ===
nsis (2.51-1) unstable; urgency=medium

  * New upstream release
    - Refresh all patches for 2.51
    - Escape the NSISCALL $STDCALL variable in the CPPDEFINES tuple

  * Bump S-V to 3.9.8 without changes needed
  * Run wrap-and-sort -sat on debian packaging files

 -- Didier Raboud <odyx@debian.org>  Fri, 08 Apr 2016 13:51:08 +0200

=== debian/control ===
Source: nsis
Section: devel
Priority: optional
Maintainer: Thomas Gaugler <thomas@dadie.net>
Uploaders:
 Didier Raboud <odyx@debian.org>,
Build-Depends:
 debhelper (>= 9),
 docbook-xsl-ns,
 docbook5-xml,
 html2text,
 libcppunit-dev,
 mingw-w64 (>= 1.0),
 scons (>= 1.2.0),
 xsltproc,
 zlib1g-dev,
Standards-Version: 3.9.8
Homepage: http://nsis.sourceforge.net/
Vcs-Git: https://alioth.debian.org/anonscm/git/collab-maint/nsis.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/nsis.git

Package: nsis
Architecture: any
Depends:
 nsis-common (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 mingw-w64 (>= 1.0),
 nsis-doc (>= ${source:Version}),
 nsis-pluginapi (>= ${source:Version}),
 wine [amd64 i386 kfreebsd-amd64 kfreebsd-i386 powerpc],
Description: Nullsoft Scriptable Install System (modified for Debian)
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 NSIS creates installers that are capable of installing, uninstalling,
 setting system settings, extracting files, etc. Because it's based on
 script files, you can fully control every part of your installers. The
 script language supports variables, functions, string manipulation,
 just like a normal programming language - but designed for the creation
 of installers. Even with all these features, NSIS is still the smallest
 installer system available. With the default options, it has an overhead
 of only 34 KB.

Package: nsis-common
Architecture: all
Depends:
 ${misc:Depends},
Replaces:
 nsis (<< 2.46-4),
Breaks:
 nsis (<< 2.46-4),
Description: Nullsoft Scriptable Install System stubs and plugins
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains the stubs and plugins of NSIS.

Package: nsis-pluginapi
Architecture: all
Depends:
 ${misc:Depends},
Replaces:
 nsis (<< 2.46-4),
Breaks:
 nsis (<< 2.46-4),
Recommends:
 mingw-w64 (>= 1.0),
Enhances:
 nsis (>= ${source:Version}),
Description: Nullsoft Scriptable Install System plugin API
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains the header and library files for developing
 NSIS plugins.

Package: nsis-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
Replaces:
 nsis (<< 2.46-4),
Breaks:
 nsis (<< 2.46-4),
Description: Nullsoft Scriptable Install System documentation
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains examples and the documentation in HTML format.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Exclude .svn directories from packages
export DH_ALWAYS_EXCLUDE=.svn

VERSION=$(shell dpkg-parsechangelog | sed -n 's/^Version: *//p')
PREFIX=/usr
DATADIR=$(PREFIX)/share/nsis
DOCDIR=$(PREFIX)/share/doc/nsis
SYSCONF=/etc
BUILDDIR=build
BUILDTYPE=release
TESTDIR=$(CURDIR)/$(BUILDDIR)/test

# Variables for Win32 cross compiler
XGCC_W32 = i686-w64-mingw32-gcc
ifneq ($(strip $(XGCC_W32)),)
	XGCC_W32_PATH = $(abspath $(shell $(XGCC_W32) -print-file-name=libkernel32.a)/../..)
	XGCC_W32_PREFIX = $(subst -gcc,-,$(XGCC_W32))
endif

# Evaluate parallel build option
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	SCONSFLAGS = -j $(NUMJOBS)
endif

# Honor hardening flags
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
SCONSHOSTFLAGS = APPEND_CCFLAGS="-fgnu89-inline $(CFLAGS) $(CPPFLAGS)" \
  APPEND_LINKFLAGS="$(LDFLAGS)"

SCONSOPTS = $(SCONSFLAGS) VERSION=$(VERSION) \
  PREFIX=$(PREFIX) PREFIX_CONF=$(SYSCONF) CHMDOCS=0 \
  STRIP_CP=no \
  $(if $(findstring nostripfull,$(DEB_BUILD_OPTIONS)),STRIP_W32=no,)

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
BUILDTYPE=debug
SCONSOPTS += DEBUG=yes
endif

ifdef XGCC_W32_PATH
SCONSOPTS += PREFIX_PLUGINAPI_INC=$(XGCC_W32_PATH)/include/ \
  PREFIX_PLUGINAPI_LIB=$(XGCC_W32_PATH)/lib/ \
  XGCC_W32_PREFIX=$(XGCC_W32_PREFIX)
endif

COMMA := ,

UTILS_ALL = 'Library/LibraryLocal,Library/RegTool,MakeLangId,Makensisw,NSIS Menu,UIs,SubStart,VPatch/Source/GenPat,zip2exe'

IGNORE_UTILS_NSIS   := $(subst Library/LibraryLocal$(COMMA),,$(UTILS_ALL))
IGNORE_UTILS_NSIS   := $(subst $(COMMA)VPatch/Source/GenPat,,$(IGNORE_UTILS_NSIS))
IGNORE_UTILS_COMMON := $(subst $(COMMA)Library/RegTool$,,$(UTILS_ALL))
IGNORE_UTILS_COMMON := $(subst $(COMMA)UIs,,$(IGNORE_UTILS_COMMON))

IGNORE_UTILS_CLEAN  := $(IGNORE_UTILS_COMMON)
IGNORE_UTILS_CLEAN  := $(subst Library/LibraryLocal$(COMMA),,$(UTILS_ALL))
IGNORE_UTILS_CLEAN  := $(subst $(COMMA)SubStart,,$(IGNORE_UTILS_CLEAN))
IGNORE_UTILS_CLEAN  := $(subst $(COMMA)VPatch/Source/GenPat,,$(IGNORE_UTILS_CLEAN))

SCONSOPTS_HOST   := $(SCONSHOSTFLAGS) $(SCONSOPTS) \
  SKIPUTILS=$(IGNORE_UTILS_NSIS) SKIPDOC=COPYING
SCONSOPTS_COMMON := $(SCONSOPTS) SKIPUTILS=$(IGNORE_UTILS_COMMON) \
  SKIPDOC=COPYING
SCONSOPTS_CLEAN  := $(SCONSOPTS) SKIPUTILS=$(IGNORE_UTILS_CLEAN)

INSTALL_nsis = install-utils install-compiler install-conf
INSTALL_FLAGS_nsis = $(SCONSOPTS_HOST)
INSTALL_nsis-common = install-stubs install-plugins install-data install-utils
INSTALL_FLAGS_nsis-common = $(SCONSOPTS_COMMON)
INSTALL_nsis-pluginapi = install-pluginapi
INSTALL_FLAGS_nsis-pluginapi = $(SCONSOPTS_COMMON)
INSTALL_nsis-doc = install-examples install-doc
INSTALL_FLAGS_nsis-doc = $(SCONSOPTS_HOST)

# Exclude test scripts which are not appropriate for POSIX platforms.
IGNORE_TESTS = makensis.nsi|gfx.nsi

# Path to .nsi scripts
SCRIPTS_PATH = $(DOCDIR)/Examples

define DO_SCONS_INSTALL
	scons $(INSTALL_FLAGS_$(1)) PREFIX_DEST="$(CURDIR)/debian/$(1)" $(INSTALL_$(1)) || exit 1;
endef

# Substitute reference to License text file in Modern UI examples
# with source file to enable their compilation with makensis
define SANITIZE_MODERN_UI
	for f in $$(find "$(1)" -type f -name '*.nsi' -print0 | xargs -0 -n 1 basename); \
	do \
		sed -i \
		-e "s&\$${NSISDIR}\\\\Docs\\\\Modern UI\\\\License.txt&$${f}&g" \
		"$(1)/$${f}"; \
	done
endef

# Replace duplicate files with symbolic link
define SYMLINK_DUPLICATES
	for f in $$(ls -1 "$(1)"); \
	do \
		cmp -s "$(1)/$${f}" "$(2)/$${f}"; \
		if [ $$? -eq 0 ]; \
		then \
			ln -sf "$(3)/$${f}" "$(2)/$${f}"; \
			echo $${f}; \
		fi; \
	done
endef

%:
	dh "$@"

override_dh_auto_clean:
	scons -c $(SCONSOPTS_CLEAN) 2>&1
	-rm -rf .sconf_temp .sconsign.dblite SCons/Tools/crossmingw.pyc build config.log .test $(TESTDIR)
	-rm -f Source/exehead/sconf.h Source/version.h Source/defines.h config.log

$(BUILDDIR)/NEWS:
	scons $(SCONSOPTS_HOST) Docs/src; \
	html2text -nobs "$(BUILDDIR)/$(BUILDTYPE)/Docs/html/AppendixF.html" | \
	sed -e '0,/^\*\*\*\*\*/c\NSIS Release Notes (automatically converted from AppendixF.html)' -e 's/F\.[.0-9]* //g' -e 's/^\*\*\*\** *\([^*]*\)  *\**\*\*\*/\n\1\n/g' -e '/Changelog/d' -e '/^NSIS_1.x_version_history/,/^=/c\    http://nsis.sourceforge.net/download/nsis1/' -e 's/^\(Released.*\)/    \1\n/g' | cat -s > "$@"

# Convert DocBook to man page
$(BUILDDIR)/%.1: debian/%.xml
	xsltproc --nonet --output $@ $<

override_dh_auto_build-arch: $(BUILDDIR)/NEWS $(BUILDDIR)/GenPat.1 $(BUILDDIR)/LibraryLocal.1 $(BUILDDIR)/makensis.1
	scons $(SCONSOPTS_HOST) utils makensis

override_dh_auto_build-indep: $(BUILDDIR)/NEWS
ifdef XGCC_W32_PATH
	scons $(SCONSOPTS_HOST) makensis
	scons $(SCONSOPTS_COMMON) stubs plugins utils
	html2text -style pretty -nobs -o "$(BUILDDIR)/README.Modern UI" "Contrib/Modern UI/Readme.html"
	html2text -style pretty -nobs -o "$(BUILDDIR)/README.Modern UI 2" "Contrib/Modern UI 2/Readme.html"
	html2text -style pretty -nobs -o $(BUILDDIR)/README.VPatch Contrib/VPatch/Readme.html
	html2text -style pretty -nobs -o $(BUILDDIR)/README.InstallOptions Contrib/InstallOptions/Readme.html
	html2text -style pretty -nobs -o $(BUILDDIR)/README.MultiUser Contrib/MultiUser/Readme.html
	html2text -style pretty -nobs -o $(BUILDDIR)/README.nsDialogs Contrib/nsDialogs/Readme.html
endif

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	scons $(SCONSOPTS_HOST) test-code
endif

override_dh_auto_test-indep:
ifdef XGCC_W32_PATH
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	test -x "$(BUILDDIR)/$(BUILDTYPE)/makensis/makensis" && \
	scons $(SCONSOPTS_HOST) PREFIX_DEST="$(TESTDIR)"\
		$(INSTALL_nsis) $(INSTALL_nsis-doc) && \
	scons $(SCONSOPTS_COMMON) PREFIX_DEST="$(TESTDIR)" \
		$(INSTALL_nsis-common) && \
	$(call SANITIZE_MODERN_UI,$(TESTDIR)$(DOCDIR)/Examples/Modern UI) && \
	for script_path in $(TESTDIR)$(SCRIPTS_PATH)/*.nsi \
		$(TESTDIR)$(SCRIPTS_PATH)/*/*.nsi; do \
		script=$${script_path#$(TESTDIR)$(SCRIPTS_PATH)/}; \
		if [ "$${script%/*}" != "$${script}" ]; then \
			mkdir -p "$(TESTDIR)/$${script%/*}"; \
		fi; \
		case $${script} in \
		$(IGNORE_TESTS)) ;; \
		*) \
		if [ -f "$${script_path}" ]; then \
			PATH=$(TESTDIR)$(PREFIX)/bin:$(PATH) \
			NSISDIR=$(TESTDIR)$(DATADIR) \
			NSISCONFDIR=$(TESTDIR)$(SYSCONF) \
			"$(TESTDIR)$(PREFIX)/bin/makensis" \
			"$${script_path}" \
			-X"OutFile \"$(TESTDIR)/$${script%.nsi}.exe\"" \
			|| exit 1; \
		fi;; \
		esac; \
	done; 
	# Fail the build if libwinpthread is needed at runtime (see #722898)
	test `find $(TESTDIR)$(DATADIR)/Plugins -iname "*.dll" -exec objdump -p {} \; | grep -E "file format|DLL Name" | grep -cim1 libwinpthread` -eq 0
endif
endif

override_dh_auto_install-arch:
	$(foreach p,$(shell dh_listpackages -a),$(call DO_SCONS_INSTALL,$(p)))

override_dh_fixperms-arch:
	dh_fixperms
	find "$(CURDIR)/debian/nsis/$(SYSCONF)" \
		-type f -perm /111 -exec chmod a-x {} \;

override_dh_auto_install-indep:
ifdef XGCC_W32_PATH
	$(foreach p,$(shell dh_listpackages -i),$(call DO_SCONS_INSTALL,$(p)))
	# Exclude any architecture dependent binaries from nsis-common
	rm -rf "$(CURDIR)/debian/nsis-common$(PREFIX)/bin"
	# Clean up examples and documentation
	# The docs file can't seem to have spaces within the file name(s)
	dh_installdocs -pnsis-doc "$(BUILDDIR)/README.Modern UI" \
		"$(BUILDDIR)/README.Modern UI 2"
	rm "debian/nsis-doc$(DOCDIR)/Docs/Modern UI/License.txt"
	rm "debian/nsis-doc$(DOCDIR)/Docs/Modern UI 2/License.txt"
	rm "debian/nsis-doc$(DOCDIR)/Docs/NSISdl/License.txt"
	$(call SANITIZE_MODERN_UI,$(CURDIR)/debian/nsis-doc$(DOCDIR)/Examples/Modern UI)
	# Replace duplicate image files with symbolic links
	$(call SYMLINK_DUPLICATES,$(CURDIR)/debian/nsis-doc$(DOCDIR)/Docs/Modern UI/images,$(CURDIR)/debian/nsis-doc$(DOCDIR)/Docs/Modern UI 2/images,../../Modern UI/images)

endif

override_dh_compress-indep:
	dh_compress -X.nlf -X.nsh -X.nsi -X.dll
